;------------------------------------------------
;- Object:   SysTrayIconEx UserLibrary
;- Version:  1.0, May 2006
;- Author:   flype - flype@altern.org
;- Requir.:  PureBasic 4.0 / TailBite 1.3 PR 1.0
;------------------------------------------------

Procedure.l MyWindowCallback(hWindow.l, message.l, wParam.l, lParam.l) 
  
  result = #PB_ProcessPureBasicEvents 
  
  Select message 
    
    Case #WM_NOTIFYICON
      
      ; wParam: NotifyIcon Id
      ; lParam: NotifyIcon EventType
      
      Select lParam
        
        Case #WM_CONTEXTMENU       : StatusBarText(0, 0, Str(wParam) + ": Context Menu")
        Case #WM_MOUSEMOVE         : StatusBarText(0, 0, Str(wParam) + ": Mouse moved")
        Case #WM_LBUTTONDOWN       : StatusBarText(0, 0, Str(wParam) + ": Left Mouse Clicked")
        Case #WM_MBUTTONDOWN       : StatusBarText(0, 0, Str(wParam) + ": Middle Mouse Clicked")
        Case #WM_RBUTTONDOWN       : StatusBarText(0, 0, Str(wParam) + ": Right Mouse Clicked")
        Case #WM_LBUTTONDBLCLK     : StatusBarText(0, 0, Str(wParam) + ": Left Mouse DblClicked")
        Case #WM_MBUTTONDBLCLK     : StatusBarText(0, 0, Str(wParam) + ": Middle Mouse DblClicked")
        Case #WM_RBUTTONDBLCLK     : StatusBarText(0, 0, Str(wParam) + ": Right Mouse DblClicked")
        
        Case #NIN_SELECT           : StatusBarText(0, 0, Str(wParam) + ": Select")
        Case #NIN_KEYSELECT        : StatusBarText(0, 0, Str(wParam) + ": KeySelect")
        
        Case #NIN_BALLOONSHOW      : StatusBarText(0, 0, Str(wParam) + ": Balloon Opened")
        Case #NIN_BALLOONTIMEOUT   : StatusBarText(0, 0, Str(wParam) + ": Balloon Refused")
        Case #NIN_BALLOONUSERCLICK : StatusBarText(0, 0, Str(wParam) + ": Balloon Accepted")
        Case #NIN_BALLOONHIDE      : StatusBarText(0, 0, Str(wParam) + ": Balloon Closed")
        
      EndSelect
      
  EndSelect 
  
  ProcedureReturn result
  
EndProcedure 

If OpenWindow(0, 0, 0, 295, 135, "SysTrayIconEx", #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
  
  hWnd  = WindowID(0)
  
  If CreateStatusBar(0, hWnd)
    AddStatusBarField(295)
  EndIf
  
  If CreateGadgetList(hWnd)
    ButtonGadget(0,   5,  5, 140, 20, "SetActiveSysTrayIconEx()")
    ButtonGadget(1,   5, 30, 140, 20, "HideSysTrayIconEx()", #PB_Button_Toggle)
    ButtonGadget(2,   5, 55, 140, 20, "SysTrayIconBalloonEx()")
    ButtonGadget(3,   5, 80, 140, 20, "SysTrayIconToolTipEx()")
    ButtonGadget(4, 150,  5, 140, 20, "SetActiveSysTrayIconEx()")
    ButtonGadget(5, 150, 30, 140, 20, "HideSysTrayIconEx()", #PB_Button_Toggle)
    ButtonGadget(6, 150, 55, 140, 20, "SysTrayIconBalloonEx()")
    ButtonGadget(7, 150, 80, 140, 20, "SysTrayIconToolTipEx()")
  EndIf
  
  Info.s
  Info + "This ballon handle those events :" + #LF$ + #LF$
  Info + "#NIN_BALLOONSHOW" + #LF$
  Info + "#NIN_BALLOONTIMEOUT" + #LF$
  Info + "#NIN_BALLOONUSERCLICK" + #LF$
  Info + "#NIN_BALLOONHIDE"
  
  Tip.s
  Tip + "SysTrayIconEx UserLibrary" + #LF$
  Tip + "for PureBasic 4.0" + #LF$
  
  AddSysTrayIconEx(1, hWnd, LoadIcon_(0, #IDI_EXCLAMATION), "ToolTip 1")
  AddSysTrayIconEx(0, hWnd, LoadIcon_(0, #IDI_QUESTION), "ToolTip 0")
  
  SetWindowCallback(@MyWindowCallback()) 
  
  Repeat 
    
    Select WaitWindowEvent()
      
      Case #PB_Event_CloseWindow
        Break
        
      Case #PB_Event_Gadget 
        Select EventGadget()
          Case 0 : SetActiveSysTrayIconEx(0, hWnd) 
          Case 1 : HideSysTrayIconEx(0, hWnd, GetGadgetState(1)) 
          Case 2 : SysTrayIconBalloonEx(0, hWnd, "Information", Info, 1000, #NIIF_INFO) 
          Case 3 : SysTrayIconToolTipEx(0, hWnd, Tip + "Item 0") : SetActiveSysTrayIconEx(0, hWnd) 
          Case 4 : SetActiveSysTrayIconEx(1, hWnd) 
          Case 5 : HideSysTrayIconEx(1, hWnd, GetGadgetState(5)) 
          Case 6 : SysTrayIconBalloonEx(1, hWnd, "Information", Info, 1000, #NIIF_ERROR) 
          Case 7 : SysTrayIconToolTipEx(1, hWnd, Tip + "Item 1") : SetActiveSysTrayIconEx(1, hWnd) 
        EndSelect
    EndSelect 
    
  ForEver
  
  RemoveSysTrayIconEx(1, hWnd)
  RemoveSysTrayIconEx(0, hWnd)
  
EndIf

End

; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 76
; Folding = +
; EnableXP
; UseIcon = test_0.ico