;------------------------------------------------------------------------------------------------
;- Object:   SysTrayIconEx UserLibrary
;- Version:  1.0, May 2006
;- Author:   flype - flype@altern.org
;- Requir.:  PureBasic 4.0 / TailBite 1.3 PR 1.2
;------------------------------------------------------------------------------------------------


EnableExplicit


XIncludeFile "SysTrayIconRes.pb"


;------------------------------------------------------------------------------------------------
; AddSysTrayIconEx(uID.l, hWindow.l, hIcon.l [, tip.s])
; RemoveSysTrayIconEx(uID.l, hWindow.l)
; SysTrayIconToolTipEx(uID.l, hWindow.l, tip.s)
; HideSysTrayIconEx(uID.l, hWindow.l, state.l)
; SetActiveSysTrayIconEx(uID.l, hWindow.l)
; SysTrayIconBalloonEx(uID.l, hWindow.l, title.s, message.s, timeOut.l [, flags.l]) 
;------------------------------------------------------------------------------------------------


;------------------------------------------------------------------------------------------------
; Compatibility : Microsoft Windows 95+
;------------------------------------------------------------------------------------------------

ProcedureDLL.l AddSysTrayIconEx(uID.l, hWindow.l, hIcon.l)
  
  Protected nid.NOTIFYICONDATA_95
  
  nid\cbSize           = #NOTIFYICONDATA_V1_SIZE
  nid\uID              = uID
  nid\hwnd             = hWindow
  nid\hIcon            = hIcon
  nid\uFlags           = #NIF_MESSAGE | #NIF_ICON
  nid\uCallbackMessage = #WM_NOTIFYICON
  
  ProcedureReturn Shell_NotifyIcon_(#NIM_ADD, @nid)
  
EndProcedure
ProcedureDLL.l AddSysTrayIconEx2(uID.l, hWindow.l, hIcon.l, tip.s)
  
  Protected nid.NOTIFYICONDATA_2K
  
  nid\uID              = uID
  nid\hwnd             = hWindow
  nid\hIcon            = hIcon
  nid\uFlags           = #NIF_MESSAGE | #NIF_ICON | #NIF_TIP
  nid\uCallbackMessage = #WM_NOTIFYICON
  
  If OSVersion() >= #PB_OS_Windows_2000
    PokeS(@nid\szTip, tip, 128)
    nid\cbSize = #NOTIFYICONDATA_V2_SIZE
  Else
    PokeS(@nid\szTip, tip, 64)
    nid\cbSize = #NOTIFYICONDATA_V1_SIZE
  EndIf
  
  ProcedureReturn Shell_NotifyIcon_(#NIM_ADD, @nid)
  
EndProcedure
ProcedureDLL.l RemoveSysTrayIconEx(uID.l, hWindow.l)
  
  Protected nid.NOTIFYICONDATA_95
  
  nid\cbSize = #NOTIFYICONDATA_V1_SIZE
  nid\uID    = uID
  nid\hwnd   = hWindow
  
  ProcedureReturn Shell_NotifyIcon_(#NIM_DELETE, @nid)
  
EndProcedure
ProcedureDLL.l SysTrayIconToolTipEx(uID.l, hWindow.l, tip.s)
  
  Protected nid.NOTIFYICONDATA_2K
  
  nid\uID    = uID
  nid\hwnd   = hWindow
  nid\uFlags = #NIF_TIP
  
  If OSVersion() >= #PB_OS_Windows_2000
    PokeS(@nid\szTip, tip, 128)
    nid\cbSize = #NOTIFYICONDATA_V2_SIZE
  Else
    PokeS(@nid\szTip, tip, 64)
    nid\cbSize = #NOTIFYICONDATA_V1_SIZE
  EndIf
  
  ProcedureReturn Shell_NotifyIcon_(#NIM_MODIFY, @nid)
  
EndProcedure


;------------------------------------------------------------------------------------------------
; Compatibility : Microsoft Windows 2000+
;------------------------------------------------------------------------------------------------

ProcedureDLL.l HideSysTrayIconEx(uID.l, hWindow.l, state.l)
  
  Protected nid.NOTIFYICONDATA_2K
  
  If OSVersion() >= #PB_OS_Windows_2000
    
    nid\cbSize      = #NOTIFYICONDATA_V2_SIZE
    nid\uID         = uID
    nid\hwnd        = hWindow
    nid\uFlags      = #NIF_STATE
    nid\dwStateMask = #NIS_HIDDEN
    
    If state
      nid\dwState = #NIS_HIDDEN
    EndIf
    
    ProcedureReturn Shell_NotifyIcon_(#NIM_MODIFY, @nid) 
    
  EndIf
  
EndProcedure
ProcedureDLL.l SetActiveSysTrayIconEx(uID.l, hWindow.l)
  
  Protected nid.NOTIFYICONDATA_2K
  
  If OSVersion() >= #PB_OS_Windows_2000
    
    nid\cbSize = #NOTIFYICONDATA_V2_SIZE
    nid\uID    = uID
    nid\hwnd   = hWindow
    
    ProcedureReturn Shell_NotifyIcon_(#NIM_SETFOCUS, @nid) 
    
  EndIf
  
EndProcedure
ProcedureDLL.l SysTrayIconBalloonEx(uID.l, hWindow.l, title.s, message.s, timeOut.l) 
  
  Protected nid.NOTIFYICONDATA_2K
  
  If OSVersion() >= #PB_OS_Windows_XP
    nid\cbSize = #NOTIFYICONDATA_V3_SIZE
  ElseIf OSVersion() >= #PB_OS_Windows_2000
    nid\cbSize = #NOTIFYICONDATA_V2_SIZE
  Else
    ProcedureReturn #False
  EndIf
  
  nid\uVersion = #NOTIFYICON_VERSION 
  Shell_NotifyIcon_(#NIM_SETVERSION, @nid)
  
  nid\uID         = uID
  nid\hwnd        = hWindow
  nid\dwInfoFlags = #NIIF_INFO
  nid\uFlags      = #NIF_INFO
  nid\uTimeout    = timeOut
  
  PokeS(@nid\szInfo, message, 256) 
  PokeS(@nid\szInfoTitle, title, 64)
  
  ProcedureReturn Shell_NotifyIcon_(#NIM_MODIFY, @nid) 
  
EndProcedure
ProcedureDLL.l SysTrayIconBalloonEx2(uID.l, hWindow.l, title.s, message.s, timeOut.l, flags.l) 
  
  Protected nid.NOTIFYICONDATA_2K
  
  If OSVersion() >= #PB_OS_Windows_XP
    nid\cbSize = #NOTIFYICONDATA_V3_SIZE
  ElseIf OSVersion() >= #PB_OS_Windows_2000
    nid\cbSize = #NOTIFYICONDATA_V2_SIZE
  Else
    ProcedureReturn #False
  EndIf
  
  nid\uVersion = #NOTIFYICON_VERSION 
  Shell_NotifyIcon_(#NIM_SETVERSION, @nid)
  
  nid\uID         = uID
  nid\hwnd        = hWindow
  nid\dwInfoFlags = flags
  nid\uFlags      = #NIF_INFO
  nid\uTimeout    = timeOut
  
  PokeS(@nid\szInfo, message, 256) 
  PokeS(@nid\szInfoTitle, title, 64)
  
  ProcedureReturn Shell_NotifyIcon_(#NIM_MODIFY, @nid) 
  
EndProcedure


; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 190
; Folding = A9
; EnableXP