;-----------------------------------------------------------
;- Object:   NotifyIcon UserLibrary
;- Version:  1.1, May 2006
;-           
;- Requir.:  PureBasic 4.0
;-           TailBite 1.3 PR 1.0
;-           
;- Author:   flype - flype@altern.org
;-           
;- Descr.    Microsoft SHELL_NOTIFYICON
;-           Functions for Systray Icon (shellapi.h)
;-----------------------------------------------------------


;-----------------------------------------------------------
; Constants
;-----------------------------------------------------------

Enumeration ; #WM
  #WM_USER       = $400
  #WM_NOTIFYICON = $400 + $7258
EndEnumeration
Enumeration ; #NIF
  #NIF_MESSAGE = $01 ; 95+
  #NIF_ICON    = $02 ; 95+
  #NIF_TIP     = $04 ; 95+
  #NIF_STATE   = $08 ; 95+
  #NIF_INFO    = $10 ; 2000+
  #NIF_GUID    = $20 ; XP+ Reserved
EndEnumeration
Enumeration ; #NIIF
  #NIIF_NONE      = $00 ; 2000+
  #NIIF_INFO      = $01 ; 2000+
  #NIIF_WARNING   = $02 ; 2000+
  #NIIF_ERROR     = $03 ; 2000+
  #NIIF_USER      = $04 ; XPSP2+
  #NIIF_ICON_MASK = $0F ; XP+ Reserved
  #NIIF_NOSOUND   = $10 ; XP+ Reserved
EndEnumeration
Enumeration ; #NIM
  #NIM_ADD        = 0 ; 95+
  #NIM_MODIFY     = 1 ; 95+
  #NIM_DELETE     = 2 ; 95+
  #NIM_SETFOCUS   = 3 ; 2000+
  #NIM_SETVERSION = 4 ; 2000+
EndEnumeration
Enumeration ; #NIN
  #NINF_KEY             = 1
  #NIN_SELECT           = $400
  #NIN_KEYSELECT        = $401
  #NIN_BALLOONSHOW      = $402 ; XP+
  #NIN_BALLOONHIDE      = $403 ; XP+
  #NIN_BALLOONTIMEOUT   = $404 ; XP+
  #NIN_BALLOONUSERCLICK = $405 ; XP+
EndEnumeration
Enumeration ; #NIS
  #NIS_HIDDEN     = 1 ; 2000+
  #NIS_SHAREDICON = 2 ; 2000+
EndEnumeration
Enumeration ; #NOTIFY
  #NOTIFYICON_VERSION     = 3   ; 2000+
  #NOTIFYICONDATA_V1_SIZE = 88  ; 95+
  #NOTIFYICONDATA_V2_SIZE = 488 ; 2000+
  #NOTIFYICONDATA_V3_SIZE = 504 ; XP+
EndEnumeration


;-----------------------------------------------------------
; Structures
;-----------------------------------------------------------

Structure NOTIFYICONDATA_95
  cbSize.l
  hwnd.l 
  uID.l 
  uFlags.l 
  uCallbackMessage.l 
  hIcon.l 
  szTip.b[64] 
EndStructure 
Structure NOTIFYICONDATA_2K Extends NOTIFYICONDATA_95
  szTipEx.b[64] 
  dwState.l
  dwStateMask.l 
  szInfo.b[256] 
  StructureUnion 
  uTimeout.l 
  uVersion.l 
  EndStructureUnion 
  szInfoTitle.b[64]
  dwInfoFlags.l
EndStructure 
Structure NOTIFYICONDATA_XP Extends NOTIFYICONDATA_2K
  guid.GUID
EndStructure 


; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 89
; FirstLine = 2
; Folding = E9